extends RigidBody2D

export var sock = 1

var active = true

func _ready():
	apply_central_impulse(Vector2(0, -256))
	rotation_degrees = (randf() - 0.5) * 15
	set_sock(sock)

func _process(delta):
	$Star.rotate(PI * delta * 2)
	$Sock.position.y = sin(OS.get_ticks_msec() * 0.005) * 16 - 8

func set_sock(value):
	sock = value
	$Sock.self_modulate = Collectibles.SOCK_COLOR[sock]

func _on_Area_body_entered(body):
	if Collectibles.can_auto_equip(sock):
		Collectibles.equip_sock(sock, 0, body)
		pickup()
	else:
		apply_central_impulse(Vector2(0, -128))
		body.interact_node = self
		active = true
		Collectibles.sock_hud.set_icon(1)
		Collectibles.show_hud_socks(sock, true)

func _on_Area_body_exited(body):
	Collectibles.hide_hud_socks()
	if body.interact_node == self:
		body.interact_node = null
	active = false

func pickup():
	Vfx.spawn("ptcl_poof", global_position)
	queue_free()

func interact(node):
	var dropped_sock = Collectibles.worn_socks[1]
	Collectibles.equip_sock(sock, 1, node)
	set_sock(dropped_sock)
	apply_central_impulse(Vector2(0, -1024))
	add_torque((randf() - 0.5) * 6) 
	Vfx.spawn("ptcl_poof", global_position)

func _on_Timer_timeout():
	$Area/Shape.disabled = false
