extends Node

enum {
	SOCK_NONE
	SOCK_BLUE,
	SOCK_RUNNING,
	SOCK_HARD,
	SOCK_STICKY,
	SOCK_DOUBLEJUMP,
	SOCK_STINKY
	}

const SOCK_COLOR = [
		Color(0, 0, 0, 0),
		Color(0.04, 0.30, 0.82, 1),
		Color(0.97, 0.25, 0.14, 1),
		Color(0.28, 0.57, 0.64, 1),
		Color(0.16, 0.91, 0.10, 1),
		Color(0.33, 0.00, 0.99, 1),
		Color(0.84, 0.88, 0.00, 1),
		Color(0.00, 0.00, 0.00, 1),
	]

const SOCK_NAME = [
		"",
		"Синий Носок",
		"Беговой Носок",
		"Затвердевший Носок",
		"Липкий Носок",
		"Супер-синий носок",
		"Вонючий Носок",
	]

const SOCK_DESC = [
		"",
		"Прыгай до неба!",
		"Красный - значит СКОРОСТЬ.",
		"Почти сапог! Шагает по чему и кому угодно.",
		"Грязный или нет? Брось в стену - прилипнет?",
		"Наконец-то, двойной прыжок!",
		"Никто не подойдёт... Никто и не навредит!",
	]

const TEXT_PAIR = "ПАРА!!! Вы получаете эту способность навсегда."

onready var anim = $"/root/Main/HUD/UIAnim"
onready var anim2 = $"/root/Main/HUD/UIAnim2"
onready var sock_hud = $"/root/Main/HUD/Control/SockHUD"

var scene_sock = load("res://Scenes/CollectibleSock.tscn")

var sock_active = [true, false, false, false, false, false, false, false, false, false]
var worn_socks = [0, 0]

var collected_trash = 0

func equip_sock(sock, mode, node_hero):
	match mode:
		0: #Auto Pickup
			show_hud_socks(sock)
			if worn_socks[0] == sock: 
				worn_socks[0] = 0
				sock_hud.set_icon(2, sock)
				$"/root/Main/Audio/PickupSpecial".play()
			elif worn_socks[1] == sock: 
				worn_socks[1] = 0
				sock_hud.set_icon(2, sock)
				$"/root/Main/Audio/PickupSpecial".play()
			elif worn_socks[0] == 0:
				worn_socks[0] = sock
				sock_active[sock] = true
				sock_hud.set_icon(0)
			elif worn_socks[1] == 0:
				worn_socks[1] = sock
				sock_active[sock] = true
				sock_hud.set_icon(0)
			$"/root/Main/Audio/Pickup".play()
		1: #Cycle Socks
			var dropped_sock = worn_socks[1]
			worn_socks[1] = worn_socks[0]
			worn_socks[0] = sock
			sock_active[sock] = true
			sock_active[dropped_sock] = false
			show_hud_socks(dropped_sock)
			sock_hud.set_icon(1)
			$"/root/Main/Audio/SwapEquip".play()
		2: #Drop Sock
			var which_drops
			if worn_socks[0] == 0: 
				which_drops = 1
				if worn_socks[1] == 0:
					which_drops = -1
			elif worn_socks[1] == 0:
				which_drops = 0
			else:
				which_drops = randi() % 2
				
			if which_drops != -1:
				sock_active[worn_socks[which_drops]] = false
				call_deferred("spawn_dropped_sock", worn_socks[which_drops], node_hero)
				worn_socks[which_drops] = 0
				$"/root/Main/Audio/Hurt2".play()
				show_hud_socks()
	node_hero.platforming_reset()
	node_hero.get_node("Sprite/SpriteSocks").material.set_shader_param("sock_l", SOCK_COLOR[worn_socks[0]])
	node_hero.get_node("Sprite/SpriteSocks").material.set_shader_param("sock_r", SOCK_COLOR[worn_socks[1]])
	sock_hud.update_display()
	
	if (
			worn_socks[0] == worn_socks[1] &&
			sock_active[1] &&
			sock_active[2] &&
			sock_active[3] &&
			sock_active[4] &&
			sock_active[5]
		):
		node_hero.state_manager.change_state("immobile")
		var victory_screen = load("res://Scenes/VictoryScreen.tscn").instance()
		$"/root/Main/HUD".add_child(victory_screen)

func can_auto_equip(sock):
	return (
			worn_socks[0] == 0 || worn_socks[1] == 0 || 
			worn_socks[0] == sock || worn_socks[1] == sock
		)

func spawn_dropped_sock(sock, node_hero):
	var node_sock = scene_sock.instance()
	Saves.scene_node.get_node("SavedNodes").add_child(node_sock)
	node_sock.global_position = node_hero.position
	node_sock.set_sock(sock)
	node_sock.apply_central_impulse(Vector2(node_hero.speed.x * 1.2 * randf(), 0))

func show_hud_socks(third_sock = 0, looking = false):
	if anim.current_animation != "LevelTransition":
		if looking:
			anim.play("SocksLook")
		else:
			anim.play("SocksShow")
		if third_sock != 0:
			sock_hud.show_third_sock(third_sock)
		else:
			sock_hud.hide_third_sock()

func hide_hud_socks():
	if anim.current_animation != "SocksShow":
		anim.play("SocksHide")

func show_hud_hint(hint):
	anim2.play("HintShow")
	$"/root/Main/Audio/Alert".play()
	$"/root/Main/HUD/Control/HintHUD/Label".text = hint

func hide_hud_hint():
	anim2.play("HintHide")

func toggle_hud_map():
	if !get_tree().paused:
		pause_mode = PAUSE_MODE_PROCESS
		get_tree().paused = true
		$"/root/Main/HUD/Control/Map".visible = true
		var sock_containers = $"/root/Main/HUD/Control/Map/Ctrl/Ctrl/Ctrl/Ctrl".get_children()
		for i in sock_containers.size():
			if sock_active[i + 1]:
				sock_containers[i].get_node("Sock").self_modulate = SOCK_COLOR[i + 1]
			else:
				sock_containers[i].get_node("Sock").self_modulate = Color.transparent
	else:
		get_tree().paused = false
		$"/root/Main/HUD/Control/Map".visible = false

func _input(event):
	if (
		event is InputEventKey && !event.is_echo() ||
		event is InputEventJoypadMotion || 
		event is InputEventJoypadButton || 
		event is InputEventAction ):
		if event.is_action("map") && event.pressed:
			toggle_hud_map()
			$"/root/Main/Audio/Pause".play()
	
	
	
	
	
	
	
	
	
	
	
