extends Node

const SAVEPATH = "user://savegame.save"

var play_scenes = [
	"res://Scenes/Areas/Area0.tscn",
	"res://Scenes/Areas/Area1.tscn",
	"res://Scenes/Areas/Area2.tscn",
	"res://Scenes/Areas/Area3.tscn",
]

var play_scene_saves = []

onready var scene_node = $"/root/Main/PlayArea"
var scene_idx = 0

var hero_checkpoint = Vector2(-224, 80)
var hero_checkpoint_door = ""

var start_time = 0

func _ready():
	play_scene_saves.resize(play_scenes.size())

func switch_play_scene(to_idx, door_name):
	Saves.hero_checkpoint_door = door_name
	play_scene_saves[scene_idx] = []
	for i in scene_node.get_node("SavedNodes").get_children():
		if i.is_in_group("CollectibleSock"):
			play_scene_saves[scene_idx].append({
				"position" : i.position,
				"sock" : i.sock,
			})
	scene_idx = to_idx
	
	$"/root/Main/HUD/UIAnim".play("LevelTransition")
	$"/root/Main/Audio/LevelTransition".play()

func switch_ready():
	scene_node.queue_free()
	var new_play_scene = load(play_scenes[scene_idx]).instance()
	$"/root/Main".add_child(new_play_scene)
	if play_scene_saves[scene_idx] != null:
		for i in new_play_scene.get_node("SavedNodes").get_children():
			i.free()
		for i in play_scene_saves[scene_idx]: 
			if i.has("sock"):
				var node = Collectibles.scene_sock.instance()
				new_play_scene.get_node("SavedNodes").add_child(node)
				node.global_position = i["position"]
				node.set_sock(i["sock"])
	for i in new_play_scene.get_node("Doors").get_children():
		if i.name == hero_checkpoint_door:
			$"/root/Main/Hero".global_position = i.global_position
			hero_checkpoint = i.global_position
			break
	$"/root/Main/HUD/Control/Map/Sprite".texture = load("res://Graphics/Maps/Area" + str(scene_idx) + ".png")
	scene_node = new_play_scene
	
