extends KinematicBody2D
class_name Hero


"""






					   ПОКИНЬ НАДЕЖДУ, ВСЯК СЮДА ВХОДЯЩИЙ!!!

		Этот класс (и все наследующие) - пример того, как кодить НЕ СТОИТ.

			Непоследовательное именование, всё в одном классе, а также...

		Машина состояний. Офигенная техника, но тут реализована ужасно.



						''Почему?'' - спросите Вы.

					А поинтересуйтесь у товарища ниже:

"""

var state_manager = StateManager.new(self)
var state_name

"""



"""

var speed = Vector2()
var last_frame_speed = Vector2()
var direction = 1
var last_frame_on_floor = false

var input_jump_start = 0
var input_movedir = 0.0
var coyote_time = 0
var air_jumps = 0
var interact_node = null

var can_ctrl = true
var can_move = true
var can_play = true

func _process(delta):
	$Sprite/SpriteSocks.animation = $Sprite.animation
	$Sprite/SpriteSocks.frame = $Sprite.frame

func _physics_process(delta):
	move_body(delta)

func move_body(delta):
	last_frame_speed = speed
	speed.y += delta * gravity
	speed = move_and_slide(speed, Vector2(0, -1))
	if is_on_floor():
		#Make position integer (fixates sprite on top of surfaces)
		position.y = ceil(position.y)
		#Land.
		if !last_frame_on_floor:
			land()
			Input.start_joy_vibration(0, 1.0, 0, 0.12 * speed.y / MAXFALL - 0.03)
			$SoundLand.play()
		#Stop on ledge
		if speed.x != 0 && !input_movedir && !$"FloorDetect".is_colliding(): 
			speed.x = 0
			position.x = round(position.x / 8) * 8
	#Walk off platform
	if last_frame_speed.y <= 0 && speed.y > 0:
		fall()
	if is_on_wall():
		position.x = round(position.x)
		speed.x = last_frame_speed.x
	
	if speed.x < 0:
		direction = -1.0
	elif speed.x > 0:
		direction = 1.0

func change_state(state:String):
	state_manager.change_state(state)

func state_changed():
	print("No override for state_changed() in state's script!")

const JUMPMIN = -0.0
const GRAVITYJUMP = 512.0
const GRAVITYFALL = 768.0
const MAXFALL = 512.0

const JUMPDEFAULT = -384.0
const JUMPBOOSTED = -460.0

const SPEEDDEFAULT = 310.0
const SPEEDBOOSTED = 460.0

var maxspeed = 0.0
var gravity = 0.0
var accel = 0.0
var brake = 0.0
var jump = -0.0

func platforming_reset():
	if !Collectibles.sock_active[Collectibles.SOCK_BLUE]:
		jump = JUMPDEFAULT
		$Particles/PtclSockJump.visible = false
	else:
		jump = JUMPBOOSTED
		$Particles/PtclSockJump.visible = true
		
	if !Collectibles.sock_active[Collectibles.SOCK_RUNNING]:
		maxspeed = SPEEDDEFAULT
		$Particles/PtclSockRun.visible = false
	else:
		maxspeed = SPEEDBOOSTED
		$Particles/PtclSockRun.visible = true
		
	if !Collectibles.sock_active[Collectibles.SOCK_STICKY]:
		$Particles/PtclSockSticky.visible = false
	else:
		$Particles/PtclSockSticky.visible = true
		
	if !Collectibles.sock_active[Collectibles.SOCK_DOUBLEJUMP]:
		$Particles/PtclSockDJump.visible = false
	else:
		$Particles/PtclSockDJump.visible = true
	
	accel = 256.0
	brake = 256.0
	if speed.y >= 0:
		gravity = GRAVITYFALL
	else:
		gravity = GRAVITYJUMP
	$Cam.position = Vector2()
	recover_jumps()
	if input_movedir:
		input_move(input_movedir)
	if last_frame_on_floor:
		if speed.x == 0:
			$Anim.play("Idle")
		elif input_movedir != 0.0:
			$Anim.play("Run")
		else:
			$Anim.play("RunStop")

func stop_on_hazard(area):
	if !input_movedir && area.is_in_group("Hazard"):
		speed.x = 0

func fall():
	gravity = GRAVITYFALL
	if last_frame_on_floor: #Walking off a platform
		last_frame_on_floor = false
		coyote_time = OS.get_ticks_msec()
	if speed.y > MAXFALL:
		speed.y = MAXFALL

func land():
	recover_jumps()
	last_frame_on_floor = true
	Vfx.spawn("ptcl_jump", position + Vector2(0, 32), speed.angle())
	$Particles/PtclSockJump.emitting = false

func recover_jumps():
	if Collectibles.sock_active[Collectibles.SOCK_DOUBLEJUMP]:
		air_jumps = 1
		$Particles/PtclSockDJump.emitting = false

func transition_ready():
	Saves.switch_ready()

#									Input

func _input(event):
	if (
		event is InputEventKey && !event.is_echo() ||
		event is InputEventJoypadMotion || 
		event is InputEventJoypadButton || 
		event is InputEventAction ):
			if event.is_action("move_l") || event.is_action("move_r"):
				if Input.is_action_pressed("move_l") && !Input.is_action_pressed("move_r"):
					input_move(-1)
				elif !Input.is_action_pressed("move_l") && Input.is_action_pressed("move_r"):
					input_move(1)
				else:
					input_move(0)
			if event.is_action("jump"):
				if event.pressed:
					input_jump()
				else:
					input_jump_()
			if event.is_action("interact"):
				if event.pressed:
					input_interact()
			if event.is_action("debug"):
				if event.pressed:
					input_test()

func input_move(move_direction):
	input_movedir = move_direction

func input_jump():
	input_jump_start = OS.get_ticks_msec()
	
func input_jump_():
	input_jump_start = 0

func input_interact():
	if is_instance_valid(interact_node):
		interact_node.interact(self)
	else:
		Collectibles.show_hud_socks()

func input_test():
	state_manager.change_state("noclip")

#										Combat

#Who knows no defeat, knows no victory.
func hit(node):
	if node.is_in_group("Stompable") && speed.y > 0 && Collectibles.sock_active[Collectibles.SOCK_HARD]:
		node.get_parent().get_parent().hit()
		speed.y = JUMPBOOSTED
		recover_jumps()
		Vfx.spawn("ptcl_hard", position + Vector2(0, 32))
		$SoundHitEnemy.play()
	else: 
		if node.is_in_group("StaticHazard"):
			if (
					node.is_in_group("HardSockAvoids") &&
					!Collectibles.sock_active[Collectibles.SOCK_HARD] 
				):
				hit_by_static()
		elif (
				$TimerInvuln.time_left == 0
			):
			hit_by_enemy()

func hit_by_static():
	position = Saves.hero_checkpoint
	speed.y = JUMPDEFAULT * 0.5
	state_manager.change_state("hurt")
	$SoundHurt.play()

func hit_by_enemy():
	Collectibles.equip_sock(-1, 2, self)
	speed.x = -speed.x
	speed.y = JUMPDEFAULT * 0.5
	Vfx.spawn("ptcl_hurt", position + Vector2(0, 32))
	state_manager.change_state("hurt")
	$SoundHurt.play()
	



