extends Hero

func state_changed():
	platforming_reset()

func move_body(delta):
	.move_body(delta)
	if input_movedir:
		speed.x = input_movedir * maxspeed
		$Sprite.scale.x = input_movedir
	else:
		if last_frame_speed.x > 0:
			speed.x -= delta * brake
			if speed.x < 0:
				speed.x = 0
		elif last_frame_speed.x < 0:
			speed.x += delta * brake
			if speed.x > 0:
				speed.x = 0
	if is_on_wall():
		if speed.y > 0:
			if $Sprite/LedgeDetectU.enabled && !$Sprite/LedgeDetectU.is_colliding():
				if input_movedir == 0 || $Sprite/LedgeDetectL.is_colliding():
					state_manager.call_deferred("change_state", "ledgegrab")
				else:
					speed.y += JUMPDEFAULT * 0.75
					$Anim.play("Jump")
					$SoundJump.play()
			
			$Sprite/LedgeDetectU.enabled = true
			$Sprite/LedgeDetectL.enabled = true
			$Sprite/LedgeDetectV.enabled = true
		
		if Collectibles.sock_active[Collectibles.SOCK_STICKY]:
			coyote_time = OS.get_ticks_msec()
			if speed.y > 0:
				speed.y = MAXFALL * 0.25
			$Particles/PtclSockSticky.emitting = true
	else:
		$Particles/PtclSockSticky.emitting = false
		$Sprite/LedgeDetectU.enabled = false
		$Sprite/LedgeDetectL.enabled = false
		$Sprite/LedgeDetectV.enabled = false

func fall():
	.fall()
	$Anim.play("JumpFall")
	$Particles/PtclSockRun.emitting = false

func land():
	.land()
	if OS.get_ticks_msec() < input_jump_start + 500:
		call_deferred("input_jump")
	#elif can_play:
	else:
		if input_movedir:
			$Anim.play("Run")
			$Particles/PtclSockRun.emitting = true
		elif speed.x == 0:
			$Anim.play("Idle")
		else:
			$Anim.play("RunStop")

func input_move(move_direction):
	if move_direction != 0:
		if last_frame_on_floor:
			$Anim.play("Run")
			$Particles/PtclSockRun.emitting = true
		elif speed.y < 0:
			$Anim.play("Jump")
		else:
			$Anim.play("JumpFall")
		if speed.x * move_direction < maxspeed * 0.5:
			speed.x = maxspeed * move_direction * 0.5
	else:
		speed.x = speed.x * 0.2
		if can_play: 
			if last_frame_on_floor:
				$Anim.play("RunStop")
			elif speed.y < 0:
				$Anim.play("Jump")
			else:
				$Anim.play("JumpFall")
		$Particles/PtclSockRun.emitting = false
	input_movedir = move_direction

func input_jump():
	input_jump_start = OS.get_ticks_msec()
	if (
			is_on_floor() ||
			OS.get_ticks_msec() < coyote_time + 250 ||
			$Sprite/LedgeDetectU.enabled && !$Sprite/LedgeDetectU.is_colliding() && $Sprite/LedgeDetectL.is_colliding() 
		):
		last_frame_on_floor = false
		speed.y = jump
		gravity = GRAVITYJUMP
		recover_jumps()
		
		$Particles/PtclSockJump.emitting = true
		$Particles/PtclSockRun.emitting = false
		$Particles/PtclSockDJump.emitting = true
		
		Vfx.spawn("ptcl_jump", position + Vector2(0, 32))
		$Anim.play("Jump")
		$Anim.seek(0)
		$Sprite.frame = 0
		$SoundJump.play()
	elif air_jumps > 0:
		speed.y = jump - 72
		gravity = GRAVITYJUMP
		air_jumps -= 1
		
		$Particles/PtclSockDJump.emitting = false
		Vfx.spawn("ptcl_jump", position + Vector2(0, 32))
		$Anim.play("Jump")
		$Anim.seek(0)
		$Sprite.frame = 0
		$SoundJump.play()
		$SoundJumpDouble.play()

func input_jump_():
	if speed.y < JUMPMIN:
		speed.y = JUMPMIN
		$Particles/PtclSockJump.emitting = false
	input_jump_start = 0

